part of pdf;

/// Represents the collection of to see cref [PdfAnnotation] objects.
class PdfAnnotationCollection extends PdfObjectCollection
    implements _IPdfWrapper {
  // constructor
  /// Initializes a new instance of the [PdfAnnotationCollection] class with the specified page.
  PdfAnnotationCollection(PdfPage page) : super() {
    ArgumentError.checkNotNull(page, 'page');
    _page = page;
  }

  // Fields
  PdfPage _page;
  _PdfArray _annotations = _PdfArray();

  // properties
  /// Gets the annotations array.
  _PdfArray get _internalAnnotations => _annotations;
  set _internalAnnotations(_PdfArray value) {
    if (value != null) {
      _annotations = value;
    }
  }

  // public methods
  /// Adds a new annotation to the collection.
  int add(PdfAnnotation annotation) {
    ArgumentError.checkNotNull(annotation, 'annotation');
    return _doAdd(annotation);
  }

  // implementation

  int _doAdd(PdfAnnotation annot) {
    annot._setPage(_page);
    annot._element =
        (annot._element == null) ? annot._dictionary : annot._element;
    _annotations._add(_PdfReferenceHolder(annot));
    _list.add(annot);
    return count - 1;
  }

  @override
  _IPdfPrimitive _element;
}
